---------------------
PatchSet 10840 
Date: 2007/06/02 12:21:57
Author: hno
Branch: HEAD
Tag: (none) 
Log:
Bug #1983: Update the read timeout when reading from an CONNECT tunnel

Also need to deal with the timeout while sending data to the server,
or the timeout might trigger during a large PUT/POST.

Members: 
	src/tunnel.cc:1.171->1.172 

Index: squid3/src/tunnel.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tunnel.cc,v
retrieving revision 1.171
retrieving revision 1.172
diff -u -r1.171 -r1.172
--- squid3/src/tunnel.cc	2 Jun 2007 12:01:34 -0000	1.171
+++ squid3/src/tunnel.cc	2 Jun 2007 12:21:57 -0000	1.172
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tunnel.cc,v 1.171 2007/06/02 12:01:34 hno Exp $
+ * $Id: tunnel.cc,v 1.172 2007/06/02 12:21:57 hno Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -229,8 +229,6 @@
 
     debugs(26, 3, "tunnelReadServer: FD " << server.fd() << ", read   " << len << " bytes");
 
-    commSetTimeout(server.fd(), Config.Timeout.read, tunnelTimeout, this);
-
     if (len > 0) {
         server.bytesIn(len);
         kb_incr(&statCounter.server.all.kbytes_in, len);
@@ -296,6 +294,10 @@
      */
     cbdataInternalLock(this);	/* ??? should be locked by the caller... */
 
+    /* Bump the server connection timeout on any activity */
+    if (server.fd() != -1)
+	commSetTimeout(server.fd(), Config.Timeout.read, tunnelTimeout, this);
+
     if (len < 0 || errcode)
         from.error (xerrno);
     else if (len == 0 || to.fd() == -1) {
